package com.example.backend.movies.model;

import java.util.Objects;

import com.example.backend.categories.model.CategorieEntity;
import com.example.backend.core.model.BaseEntity;

import jakarta.persistence.Column;
import jakarta.persistence.Entity;
import jakarta.persistence.JoinColumn;
import jakarta.persistence.ManyToOne;
import jakarta.persistence.Table;

@Entity
@Table(name = "movies")
public class MovieEntity extends BaseEntity {

    @ManyToOne
    @JoinColumn(name = "categorieId", nullable = false)
    private CategorieEntity categorie;

    @Column(nullable = false, unique = true, length = 50)
    private String name;

    @Column(nullable = false, unique = true, length = 300)
    private String description;

    @Column(nullable = false, unique = true, length = 50)
    private String duration;

    @Column(nullable = true)
    private String image;

    public MovieEntity() {
        super();
    }

    public MovieEntity(Integer id, CategorieEntity categorie, String name, String description, String duration,
            String image) {

        this.categorie = categorie;
        this.name = name;
        this.description = description;
        this.duration = duration;
        this.image = image;
    }

    public CategorieEntity getCategorie() {
        return categorie;
    }

    public void setCategorie(CategorieEntity categorie) {
        this.categorie = categorie;
    }

    public String getName() {
        return name;
    }

    public void setName(String name) {
        this.name = name;
    }

    public String getDescription() {
        return description;
    }

    public void setDescription(String description) {
        this.description = description;
    }

    public String getDuration() {
        return duration;
    }

    public void setDuration(String duration) {
        this.duration = duration;
    }

    public String getImage() {
        return image;
    }

    public void setImage(String image) {
        this.image = image;
    }

    @Override
    public int hashCode() {
        return Objects.hash(id, categorie, name, description, duration, image);
    }

    @Override
    public boolean equals(Object obj) {
        if (this == obj)
            return true;
        if (obj == null || getClass() != obj.getClass())
            return false;
        final MovieEntity other = (MovieEntity) obj;
        return Objects.equals(other.getId(), id)
                && Objects.equals(other.getCategorie(), categorie)
                && Objects.equals(other.getName(), name)
                && Objects.equals(other.getDescription(), description)
                && Objects.equals(other.getDuration(), duration)
                && Objects.equals(other.getImage(), image);
    }

}
